import { GlobalConfigUI } from "./GlobalConfigUI";
import { InstanceConfigUI } from "./InstanceConfigUI";
import { ConfigUI } from "./ConfigUI";
import { ISettings, IConfig } from "./Settings";

export class ConfigLoaderUI extends ConfigUI {
    childConfigUI: ConfigUI;

    constructor() {
        super(null);
    }

    init(values: any) {
        var self = this;
        console.log("init");
        //read config first
        window.requester.doGet({ route: '/settings' })
            .done(function (settings: ISettings) {
                settings.config = settings.config || {} as IConfig;
                self.settings = settings;

                if ($("html").hasClass("webapp-config")) {
                    self.childConfigUI = new GlobalConfigUI(settings);
                } else {
                    if (!settings.config.ivUrl) {
                        self.alert(self.i18n("configuration-is-not-completed", settings.appInfo.addon.displayName), "warning");
                        self.hideLoader();
                        return;
                    }
                    self.childConfigUI = new InstanceConfigUI(settings);
                }
                self.childConfigUI.init(values);

            }).fail(function (response) {
                self.error(response);
            });

    }
}