import { DataStore } from "./DataStore";

export interface ISettings {
    dataStore?: DataStore;
    config: IConfig;
    resourcePath: string;
    appInfo: IAppInfo;
    i18n: Ii18nTexts;
    pageInfo: IPageInfo;
    client?: ImageVault.PinClient;
    instanceConfig: IInstanceConfig;
}
export interface IInstanceConfig extends IThumbnailSelectorData {
    altTextData?: IMetadataTextData;
    captionData?: IMetadataTextData;
    id?: number;
    html?: string;
    htmlLazy?: string;
    formatId?: number;
    effects?: ImageVault.IEffect[];
    click?: IClickInteractionData;
    puff?: IThumbnailSelectorData;
}
export interface IThumbnailSelectorData {
    formatId?: number;
    html?: string;
    effects?: ImageVault.IEffect[];
}
export interface IClickInteractionData {
    mode: string;
    customUrl?: string;
    url?: string;
}
export interface IMetadataTextData {
    choice: string;
    metadataId?: number;
    customValue?: string;
    value?: string;
}
export interface IConfig {
    requireAltText?: boolean;
    ivUrl: string;
}
interface IAppInfo {
    addon: IAddon;
}
interface IAddon {
    displayName: string;
}
interface IPageInfo {
    url: string;
    name: string;
}
export interface Ii18nTexts {
    "global-settings": string;
    "imagevault-url": string;
    "imagevault": string;
    "search": string;
    "order-by-match": string;
    "order-by-date": string;
    "order-by-date-descending": string;
    "order-by-name": string;
    "order-by-name-descending": string;
    "selected-asset": string;
    "remove": string;
    "edit": string;
    "open-imagevault": string;
    "format": string;
    "original": string;
    "width": string;
    "height": string;
    "caption": string;
    "alt-text": string;
    "image-interaction": string;
    "on-mouse-click": string;
    "do-nothing": string;
    "zoom": string;
    "link": string;
    "select-link-target": string;
    "auto-crop": string;
    "enabled": string;
    "image-optimization": string;
    "lazy-load-label": string;
    "caption-heading": string;
    "alternate-text-heading": string;
    "alt-text-from-metadata": string;
    "alt-text-custom": string;
    "alt-text-none": string;
    "remove-cached-credentials": string;
    "current-user-settings": string;
    "link-to-original": string;
    "open-imagevault-link-title": string;
    "src-set-label": string;
    "done": string;
    "you-must-supply-the-url-to-the-imagevault-service": string;
    "unsupported-imagevault-service-located-at": string;
    "imagevault-service-verified-version": string;
    "imagevault-service-does-not-meet-required-version": string;
    "failed-to-connect-to-imagevault-service": string;
    "configuration-is-not-completed": string;
    "e-001-no-input-named-x-found": string;
    "e-002-more-than-1-input-named-x-was-found": string;
    "e-003-failed-to-update-metadata-value": string;
    "e-004-failed-to-retrieve-metadata-definitions": string;
    "error-during-initialization": string;
    "ok": string;
    "cancel": string;
    "reload": string;
    "warning-image-is-scaled-to-fit-the-area": string;
    "editor-title": string;
    "editor-load-error": string;
    "cannot-find-asset-with-id-x": string;
    "failed-to-update-formats": string;
    "searching": string;
    "search-returned-0-results": string;
    "search-yielded-no-additional-results": string;
    "displaying-first-x-assets-of-y-hits": string;
    "error-performing-search": string;
    "asset-x-selected": string;
    "no-response-was-received": string;
    "no-asset-with-id-x-was-found": string;
    "the-requested-conversion-for-asset-x-could-not-be-retrieved": string;
    "the-requested-conversion-for-asset-x-has-no-html": string;
    "name": string;
    "vault": string;
    "uploaded": string;
    "uploaded-by": string;
    "error-during-validate": string;
    "license-not-active-at-x": string;
    "cached-credentials-exists": string;
    "no-cached-credentials-exists": string;
    "content-type": string;
    "pin_client_pin_code_request_no_valid_pin_code": string;
    "pin_client_poll_pin_failed_async_is_not_supported": string;
    "pin_client_poll_pin_code_returned_state_x": string;
    "pin_client_no_access_code_was_returned_from_poll_code_response": string;
    "pin_client_activation_completed": string;
    "pin_client_activation_is_required_go_to_x_to_activate": string;
    "has_expired_agreements": string;
    "has_soon_expired_agreements": string;
    "all_agreements_are_valid": string;
    "select-category": string;
    "categories": string;
    "custom-url": string;
    "enter-custom-url": string;
    "caption-from-metadata": string;
    "caption-custom": string;
    "global-settings-module-configure-vs-url": string;
    "global-settings-configure-instructions": string;
    "uilang": string;
    "asset-puff-format": string;
    "alt-text-required": string;
    "metadata-text-value-required":string;
}